remove-all-packet-headers       ;# removes all except common
add-packet-header Flags IP TCP MPSrc_rt MultiP CProbe  ;# hdrs reqd for TCP


proc my-duplex-link {ns n1 n2 bw delay queue_method queue_length SP} {
	$ns duplex-link $n1 $n2 $bw $delay $queue_method
	$ns queue-limit $n1 $n2 $queue_length
	$ns queue-limit $n2 $n1 $queue_length
	$ns queueparameters2 $n1 $n2 $SP
}


proc my-duplex-link2 {ns n1 n2 bw delay queue_method queue_length RDF RIF PCR SWITCH_MIN SWITCH_MAX SWITCH_DROP SWITCH_DROPM DOFLOW} {
	$ns simplex-link $n1 $n2 $bw $delay $queue_method
	$ns simplex-link $n2 $n1 $bw $delay DropTail4
	$ns queue-limit $n1 $n2 $queue_length
	$ns queue-limit $n2 $n1 $queue_length
	$ns queueparameters $n1 $n2 $RDF $RIF $PCR $SWITCH_MIN $SWITCH_MAX $SWITCH_DROP $SWITCH_DROPM $DOFLOW
}



#Create a simulator object 
set ns [new Simulator] 

# enable source routing

set FLOW_DC 400000

$ns mp_src_rting 1
#$ns color 0 Red
#$ns color 1 Blue
#$ns color 2 LightBlue
#$ns color 3 orange
#$ns color 4 green
#$ns color 5 magenta
#$ns color 6 black
#$ns color 7 yellow

#Open the nam trace file
#set nf stdout
#set nf [open out2.tr w]
#$ns trace-all $nf

#set f [open out.nam w]
#$ns namtrace-all $f

#set wi [open log/window.txt w]
#set wi2 [open log/window2.txt w]

#Create  nodes
for {set k 0} {$k < 24} {incr k} {
	set n($k) [$ns node]
	#enable memory optimizations for routing table
	set temp [$n($k) set src_agent_]
	$temp set largesim_ 1
}

set linkspMb  45000000
set linkspMb2 90000000


set qeu1 1
set que2 1

set ACRmin 0.001
set ACRmax 0.015
set ACRdrop1 0.36
set ACRdrop2 0.36

#Create links between the nodes
 my-duplex-link2 $ns $n(0) $n(12) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(1) $n(13) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(2) $n(14) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(3) $n(15) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(4) $n(16) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(5) $n(17) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(6) $n(18) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(7) $n(19) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(8) $n(20) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(9) $n(21) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(10) $n(22) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1
 my-duplex-link2 $ns $n(11) $n(23) 1000Mb 0ms DropTail2 100 0.0625 0.0625 $linkspMb $ACRmin $ACRmax $ACRdrop1 $ACRdrop2 $qeu1

  $ns queuePCR $n(1) $n(13) 1 2 $linkspMb2
  $ns queuePCR $n(2) $n(14) 1 1 $linkspMb2
  $ns queuePCR $n(2) $n(14) 1 3 $linkspMb2
  $ns queuePCR $n(3) $n(15) 1 2 $linkspMb2
  $ns queuePCR $n(1) $n(13) 1 3 $linkspMb2
  $ns queuePCR $n(3) $n(15) 1 1 $linkspMb2
  

 my-duplex-link $ns $n(12) $n(13) $linkspMb 4.7ms DropTail3 100 $que2
 my-duplex-link $ns $n(12) $n(17) $linkspMb 0.2ms DropTail3 100 $que2
 my-duplex-link $ns $n(12) $n(20) $linkspMb 1.7ms DropTail3 100 $que2
 my-duplex-link $ns $n(13) $n(17) $linkspMb 4.6ms DropTail3 100 $que2
 my-duplex-link $ns $n(13) $n(14) $linkspMb2 4.6ms DropTail3 100 $que2
 my-duplex-link $ns $n(13) $n(18) $linkspMb 4ms DropTail3 100 $que2
 my-duplex-link $ns $n(14) $n(15) $linkspMb2 1.5ms DropTail3 100 $que2
 my-duplex-link $ns $n(15) $n(18) $linkspMb 2.5ms DropTail3 100 $que2
 my-duplex-link $ns $n(15) $n(16) $linkspMb 2ms DropTail3 100 $que2
 my-duplex-link $ns $n(15) $n(19) $linkspMb 1.5ms DropTail3 100 $que2
 my-duplex-link $ns $n(16) $n(19) $linkspMb 1ms DropTail3 100 $que2
 my-duplex-link $ns $n(17) $n(20) $linkspMb 1.5ms DropTail3 100 $que2
 my-duplex-link $ns $n(17) $n(21) $linkspMb 7.3ms DropTail3 100 $que2
 my-duplex-link $ns $n(18) $n(19) $linkspMb 3.6ms DropTail3 100 $que2
 my-duplex-link $ns $n(18) $n(21) $linkspMb 2.7ms DropTail3 100 $que2
 my-duplex-link $ns $n(19) $n(22) $linkspMb 2.7ms DropTail3 100 $que2
 my-duplex-link $ns $n(20) $n(23) $linkspMb 6.9ms DropTail3 100 $que2
 my-duplex-link $ns $n(21) $n(23) $linkspMb 1.1ms DropTail3 100 $que2
 my-duplex-link $ns $n(22) $n(23) $linkspMb 3.5ms DropTail3 100 $que2
 





#parameters
set delete_delay 2
set lastfid_ 1

set d_free_ 1 
set u_free_ 1 
set max_agent_ 1




# An agent finished sending its packets. Detach it soon
proc Ender {ended} {
	global delete_delay
	set ns [Simulator instance]
	
	#puts "[$ns now] [clock clicks -milliseconds] entered Ender"
	#delete the agents 2 seconds later
	$ns at [expr [$ns now] + $delete_delay] "Deleter $ended"
	
	#puts "[$ns now] [clock clicks -milliseconds] did Ender"

}

# An agent finished sending its packets. Add it to the agent queue

proc Deleter {ended} {
	global  cbr null n sour dest u_free_ d_free_ l_free pathnumber
	set ns [Simulator instance]

	#puts "[$ns now] [clock clicks -milliseconds] entered Deleter"
	set i $ended


	$cbr($i) reset
	$ns detach-agent $n($sour($i)) $cbr($i)


	$null($i) reset
	$ns detach-agent $n($dest($i)) $null($i)
	
	set pathnumber($i) 0	

	set l_free($u_free_) $i
	
	incr u_free_


 
	#puts "[$ns now] [clock clicks -milliseconds] did Deleter i $i"
	
	
}

#Schedule a new agent
proc Adder {src_ dst_ data_} {
	global cbr null n ftp lastfid_ sour dest u_free_ d_free_ max_agent_ l_free pathnumber
	set ns [Simulator instance]
	#puts "[$ns now] [clock clicks -milliseconds] entered Adder"

	set found 0

	#check whether free agent is available
	
	if {$u_free_ > $d_free_} {
		set i $l_free($d_free_)
		unset l_free($d_free_)
		incr d_free_
		set found 1
	}
	
	#puts "[$ns now] [clock clicks -milliseconds] Adder finished find"
	
	#reuse the free agent found
	if {$found == 1} {
		
		$cbr($i) reset
		$ns attach-agent $n($src_) $cbr($i)
		$cbr($i) set fid_ $lastfid_
		$cbr($i) set largesim_ 1

		$cbr($i) target [$n($src_) set src_agent_]
		
		
		#set ftp($i) [$cbr($i) attach-source FTP]
		$null($i) reset
		$ns attach-agent $n($dst_) $null($i)
		$null($i) set fid_ $lastfid_

		$null($i) target [$n($dst_) set src_agent_]
		
		$ns connect $cbr($i) $null($i)

	
		#puts "[$ns now] [clock clicks -milliseconds] did Adder found i $i lastfid_ $lastfid_"
	
	#no free agent could be found. create a new agent
	} else {
	
		#number of the new agent
		set i $max_agent_
		set pathnumber($max_agent_) 0
		incr max_agent_

		set cbr($i) [new Agent/TCP/Reno]		
		$ns attach-agent $n($src_) $cbr($i)
		$cbr($i) set fid_ $lastfid_
		$cbr($i) set largesim_ 1
		
		$cbr($i) target [$n($src_) set src_agent_]
		

		set ftp($i) [$cbr($i) attach-source FTP]


		set null($i) [new Agent/TCPSink]
		$ns attach-agent $n($dst_) $null($i)
		$null($i) set fid_ $lastfid_
		$null($i) target [$n($dst_) set src_agent_]
		
		$ns connect $cbr($i) $null($i)
		
		
		
		#puts "[$ns now] [clock clicks -milliseconds] src_ $src_ dst_ $dst_ maxagent $max_agent_ lastfid_ $lastfid_ u_free_ $u_free_ d_free_ $d_free_"
	
	}
	
	

	
	
	
	$cbr($i) set agent_num_ $i
	incr lastfid_
	set sour($i) $src_
	set dest($i) $dst_
	$ftp($i) send $data_


	
	#puts "[$ns now] [clock clicks -milliseconds] did Adder"
}






set sf 12
set de 13
set ch 14
set cl 15
set ny 16
set sj 17
set sl 18
set dc 19
set la 20
set da 21
set at 22
set hs 23

source routeflow.tcl
source routeprobe.tcl


proc Finisher { } {
	global cbr lastfid_ u_free_ d_free_ max_agent_ l_free	
	set ns [Simulator instance]
	
	Flowlist
	
	#puts "[$ns now] [clock clicks -milliseconds] Finish"
	puts "[$ns now] [clock clicks -milliseconds] FINISH max_agent_ [expr $max_agent_ -1] lastfid_ [expr $lastfid_ -1] u_free_ $u_free_ d_free_ $d_free_"
	set ptr 1
	
	for {set k 1} {$k < $max_agent_} {incr k} {	
		set closelist($k) 0	
	}
	
	for {set k $d_free_} {$k < $u_free_} {incr k} {	
		set closelist($l_free($k)) 1	
	}
	
	for {set k 1} {$k < $max_agent_} {incr k} {
	
		if { $closelist($k)==0 } {
			$cbr($k) logger
		}
	
	}
	#puts "[$ns now] [clock clicks -milliseconds] did Finish"
	
	$ns halt

}


proc recordPath { agentnum path } {
	global pathnumber

	set pathnumber($agentnum) $path

}


proc Flowlist { } {
	global cbr lastfid_ u_free_ d_free_ max_agent_ l_free sour dest	 pathnumber
	set ns [Simulator instance]
	
	#puts "[$ns now] [clock clicks -milliseconds] Finish"
	#puts "[$ns now] [clock clicks -milliseconds] FINISH max_agent_ $max_agent_ lastfid_ $lastfid_ u_free_ $u_free_ d_free_ $d_free_"
	set ptr 1
	
	
	for {set m 0} {$m < 12} {incr m} {
		for {set k 0} {$k < 12} {incr k} {
			for {set p 0} {$p < 3} {incr p} {
				set flowe($m,$k,$p) 0
			}
		}
	}
	
	for {set k 1} {$k < $max_agent_} {incr k} {	
		set closelist($k) 0	
	}
	
	for {set k $d_free_} {$k < $u_free_} {incr k} {	
		set closelist($l_free($k)) 1	
	}
	
	for {set k 1} {$k < $max_agent_} {incr k} {
	
		if { $closelist($k)==0 } {
			incr flowe($sour($k),$dest($k),$pathnumber($k))
		}
	
	}
	
	for {set m 0} {$m < 12} {incr m} {
		for {set k 0} {$k < 12} {incr k} {
			if { $k != $m } { 
				for {set p 0} {$p < 3} {incr p} {
					puts "[$ns now] max_agent_ [expr $max_agent_ -1] $m $k $p num $flowe($m,$k,$p)"
				}
			}
		}
	}
	puts ""
	puts ""
	puts ""
	for {set p 0} {$p < 3} {incr p} {
		for {set m 0} {$m < 12} {incr m} {
			for {set k 0} {$k < 12} {incr k} {
				if { $k != $m } {							
					puts "[$ns now] max_agent_ [expr $max_agent_ -1] $m $k $p num $flowe($m,$k,$p)"
				}
			}
		}
	}
	
}


for {set m 0} {$m < 12} {incr m} {
	for {set k 0} {$k < 12} {incr k} {
		if {$k > $m} {
			set p([expr $k*4+$m*50]) [new Agent/CProbe]
			$ns attach-agent $n($m) $p([expr $k*4+$m*50])
			$p([expr $k*4+$m*50]) set fid_ [expr $k*2 + $FLOW_DC]
			$p([expr $k*4+$m*50]) target [$n($m) set src_agent_]

			set p([expr $k*4+1+$m*50]) [new Agent/CProbe]
			$ns attach-agent $n($k) $p([expr $k*4+1+$m*50])
			$p([expr $k*4+1+$m*50]) set fid_ [expr $m*2 + $FLOW_DC]
			$p([expr $k*4+1+$m*50]) target [$n($k) set src_agent_]

			set p([expr $k*4+2+$m*50]) [new Agent/CProbe]
			$ns attach-agent $n($m) $p([expr $k*4+2+$m*50])
			$p([expr $k*4+2+$m*50]) set fid_ [expr $k*2 + $FLOW_DC+1]
			$p([expr $k*4+2+$m*50]) target [$n($m) set src_agent_]

			set p([expr $k*4+3+$m*50]) [new Agent/CProbe]
			$ns attach-agent $n($k) $p([expr $k*4+3+$m*50])
			$p([expr $k*4+3+$m*50]) set fid_ [expr $m*2 + $FLOW_DC+1]
			$p([expr $k*4+3+$m*50]) target [$n($k) set src_agent_]
			
			Route $m $k
		}
	}
}



#Connect the agents



for {set m 0} {$m <12} {incr m} {
	for {set k 0} {$k < 12} {incr k} {
		if {$k > $m} {

			$ns connect $p([expr $k*4+$m*50]) $p([expr $k*4+$m*50+1])
			$ns connect $p([expr $k*4+$m*50+2]) $p([expr $k*4+$m*50+3])

			$ns at 0.3 "$p([expr $k*4+$m*50])  send 1"
			$ns at 0.3 "$p([expr $k*4+$m*50+1])  send 1"
			$ns at 0.3 "$p([expr $k*4+$m*50+2])  send 2"
			$ns at 0.3 "$p([expr $k*4+$m*50+3])  send 2"
		
		}
	}
}



Route2

source tam_parcali01.tcl


$ns at 300.5 "Finisher"

$ns run
